/**
* iTMS-Antenna
* (C)gachapin   ku-suke@ad-labo.com
*/
var req;
var serverPath = "http://ax.phobos.apple.com.edgesuite.net/WebObjects/MZStore.woa/wpa/MRSS/"; 
var serverParam = "?partnerId=30&LS_PARAM=http%3A%2F%2Fclick.linksynergy.com%2Ffs-bin%2Fstat%3Fid%3DYmZtSk5pzOY%26offerid%3D94348%26type%3D3%26subid%3D0%26tmpid%3D2192%26RD_PARM1%3D";
var store = "143462";
var limit = "25";
var feedTypeArr = ["iTMS New Releases","iTMS Just Added","iTunes Top Songs","iTunes Top Albums","Featured Albums","newreleases","justadded","topsongs","topalbums","featuredalbums"];
var countryArr = {
							143441:"USA",
						  	143460:"Australia",
						  	143445:"Austria",
						  	143446:"Belgium",
		 				 	143455:"Canada",
						  	143458:"Denmark",
						  	143447:"Finland",
						  	143442:"France",
						  	143443:"Germany",
						  	143448:"Greece",
						  	143449:"Ireland",
						  	143450:"Italy",
						  	143462:"Japan",
						  	143451:"Luxemborg",
						  	143452:"Netherlands",
							143461:"New Zealand",
						  	143457:"Norway",
						  	143453:"Portugal",
						  	143454:"Spain",
						  	143456:"Sweden",
				 			143459:"Switzerland",
						  	143444:"UK"
		}
var selectedType = 2;
var scrollbar, scrollArea,stretcher,loadTimer;
document.getElementById("status").innerHTML = "";
document.form.message.value = "";

function getLocalizedStrings(key){
    try {
        var ret = localizedStrings[key];
        if (ret === undefined)
            ret = key;
        return ret;
    } catch (ex) {}
    return key;
}

function StartWidget(){
	if(window.widget)
	{
	    var limitKey = widget.preferenceForKey("limit");
	    if (limitKey && limitKey.length > 0)
	    {
	        limit = limitKey;
			document.form.limit.value = limit;
	    }
		var typeKey = widget.preferenceForKey("type");
	    if (typeKey && typeKey > 0)
	    {
			selectedType = typeKey;
	    }
		var countryKey = widget.preferenceForKey("country");
	    if (countryKey && countryKey.length > 0)
	    {
	        store = countryKey;
			document.form.country.value = countryKey;
	    }
	$("prefStr").innerText =  getLocalizedStrings("Widget Preference");
	$("setNumStr").innerText =  getLocalizedStrings('ITEMs Display');
	$("setKenStr").innerText =  getLocalizedStrings('item');
	$("setCatStr").innerText =  getLocalizedStrings('Country');
	$("setFedStr").innerText =  getLocalizedStrings('FeedBack Your Message');
	$("setNameStr").innerText =  getLocalizedStrings('Name');
	$("setMesStr").innerText =  getLocalizedStrings('Message');
	}
	mousemove();
	createScrollbar();
	loadRssDoc();
}
function changeType(obj){
	selectedType = selectedType + 1;
	if(selectedType>4){
		selectedType=0;
	}
	if(window.widget)
	{
    	widget.setPreferenceForKey(selectedType,"type");
	}
	loadRssDoc();
}
function loadRssDoc(){
	clearTimeout ( loadTimer);
	$("item").innerHTML="";
	$('loading').style.display = "block";
	$('loading').style.opacity = 0.999999;
	var typeNum = selectedType+5;
	var url = serverPath + feedTypeArr[typeNum] + "/sf=" + store +"/limit="+ limit + "/rss.xml" + serverParam;
	var rssAjax = new Ajax.Request( url, {method: 'get', onSuccess: buildTopicList } ); 
}

function submitMess(){
	document.getElementById("status").innerHTML = "Sending ....";
	var name1 = document.form.name.value;
	var message1 = document.form.message.value;
	var pars1 = 'name=' + name1 + '&message=' + message1;
	
	messAjax = new Ajax.Request( 'http://deeptunes.info/widget/short2.php/dummy.xml', {postBody: pars1, onSuccess: showSuccess } ); 
}

function showSuccess(){
	document.getElementById("status").innerHTML = "Thank You!!";
	document.form.message.value = "";
	document.form.submit.disabled = true;
}

function buildTopicList(rssResponse) {
	$("line1").innerHTML = feedTypeArr[selectedType];
	$("line2").innerHTML = countryArr[store];
	$("image").innerHTML = "";
	req = rssResponse;
	var htmlStr = "";
    var items = rssResponse.responseXML.getElementsByTagName("item");
    for (var i = 0; i < items.length; i++) {
	if(i % 2==0){
		htmlStr = htmlStr + "<div class='row' onClick='showDetail(" + i + ",event);'><a href='javascript:void(0)'>";
	}else{
		htmlStr = htmlStr + "<div class='row_even' onClick='showDetail(" + i + ",event);'><a href='javascript:void(0)'>";
	}
		title = items[i].getElementsByTagName("title")[0] .firstChild.nodeValue;
		title = get70Str(title);
		if(selectedType==0||selectedType==1||selectedType==4){
		title = "- "+ title;
		}
	htmlStr = htmlStr + title + "</a></div>";
	}
	$('loading').style.display = "none";
	$('loading').style.opacity = 0.000001;
	$("item").innerHTML =  htmlStr;
	// Resize, reposition the scrollthumb
	scrollArea.reveal($("item"));
	scrollArea.refresh();
	loadTimer = setTimeout ("loadRssDoc()",3600000 );
}
// Multibyte text count
function get70Str(text)
{
		temp = "";
        count = 0;
        for (i=0; i<text.length; i++)
        {
                n = escape(text.charAt(i));
                if (n.length < 4) count++; else count+=2;
				if(count<48){
					temp= temp + text.charAt(i);
				}else{
					temp = temp + "..";
					break;
				}
        }
        return temp;
}

function getElementTextNS(prefix, local, parentElem, index) {
	result = parentElem.getElementsByTagName(local)[index];
    if (result) {
    return Try.these(
        function() {return result.childNodes[1].nodeValue;},
		function() {return result.firstChild.nodeValue;}
    );
    } else {
        return "n/a";
    }
}
var imgObj,myTimer2;
function showDetail( i ,evt){
	$('image').style.opacity = 0.00001;
	var item, line1, line2, detail1, detail2,imgDiv;
	item = req.responseXML.getElementsByTagName("item")[i];
	artist = getElementTextNS("itms", "artist", item, 0);
	album = getElementTextNS("itms", "album", item, 0);
	imgObj = new Image();
	coverArt = getElementTextNS("itms", "coverArt", item, 0);
	coverArt = coverArt.substr(0,coverArt.length-12)+"170x170-75.jpg";
	imgObj.src = coverArt;
	clearTimeout(myTimer2);
	safariOnLoad(i);
    $("line1").innerHTML = "<strong>Album:</strong><a href='javascript:void(0)' onclick='openAlbumUrl( "+ i +");'>"+album+"</a>";
	$("line2").innerHTML = "<strong>Artist:</strong><a href='javascript:void(0)' onclick='openArtistUrl( "+ i +");'>"+artist+"</a> ";
}
var timeCount =0;
function safariOnLoad(i) {
	if(imgObj.complete) {
			clearTimeout(myTimer2);
			timeCount = 0;
		if(imgObj.height>0){
			imageAppear(imgObj.src,i);
		}else{
			getBetterImage(i);
		}
	}else if(timeCount>16){
		clearTimeout(myTimer2);
		timeCount = 0;
		getBetterImage(i);
	} else {
		timeCount++;
		myTimer2 = setTimeout("safariOnLoad("+i+")", 100);
 	}
}
function imageAppear(source,k){
	$('image').innerHTML = "<img src='"+source+"' onclick='openAlbumUrl("+ k +");' width='170' height='170' onmousemove='enterJacket(event);' onmouseout='exitJacket(event);' />";
	fadeIn();
}
function getBetterImage(j){
	item = req.responseXML.getElementsByTagName("item")[j];
	result = item.getElementsByTagName("coverArt");
	coverArt = getElementTextNS("itms", "coverArt", item, result.length-1);
	imageAppear(coverArt,j);
}
var myTimer3;
var tempOpc = 0;
function fadeIn(){
	if($('image').style.opacity<1){
		tempOpc += 0.1;
		$('image').style.opacity = tempOpc;
		myTimer3 = setTimeout("fadeIn()" , 50);
	}else{
		clearTimeout(myTimer3);
		tempOpc=0;
	}
}
//-------------Scroller.js
function createScrollbar() {
	scrollbar = new AppleVerticalScrollbar(document.getElementById("barArea"));
	scrollArea = new AppleScrollArea(document.getElementById("showArea"), scrollbar);
	scrollArea.scrollsHorizontally = false;
	scrollArea.singlepressScrollPixels = 25;
	scrollArea.focus(); // for key control when first loading in Safari
}
//------------ timer
var simpleTimer = null;
window.onfocus = focus;
window.onblur = blur;
$("small").style.visibility = "hidden";
$("full").style.visibility = "block";
function onhide () {
    if (simpleTimer != null) {
        clearInterval(simpleTimer);
        simpleTimer = null;
    }
}
function focus(){
    scrollArea.focus();
    //hide small
    //if($("back").style.display == 'none'){
	    $("small").style.visibility = "hidden";
    	$("full").style.visibility = "block";
    //}
    // stop interval
    if (simpleTimer != null) {
        clearInterval(simpleTimer);
        simpleTimer = null;
    }
}
function preFocus(){
	    $("small").style.visibility = "hidden";
    	$("full").style.visibility = "block";
}
function blur(){
    //show small
    scrollArea.blur();
    //if($("back").style.display == 'none'){
	    $("small").style.visibility = "block";
    	$("full").style.visibility = "hidden";
	    // start interval
	    if (simpleTimer == null) {
	        autoPilot();
	        simpleTimer = setInterval("autoPilot();", 10000);
	    }  
    //}
}
function preBlur(){
	if (simpleTimer != null) {
	    $("small").style.visibility = "block";
    	$("full").style.visibility = "hidden";
	}
}
var pilotPoint = 0;
function autoPilot(){
	if(req!=null){
		itemCount = req.responseXML.getElementsByTagName("item").length;
		if(itemCount<=pilotPoint){
			pilotPoint = 0;
		}
		showDetail(pilotPoint,null);
		pilotPoint++
	}
}
//-------------------

function openAlbumUrl(num){
	var item , storeUrl;
	item = req.responseXML.getElementsByTagName("item")[num];
	storeUrl = item.getElementsByTagName("link")[0] .firstChild.nodeValue;
	storeUrl = storeUrl.replace( "RD_PARM1=?http" , "RD_PARM1=http" );
 	if (window.widget)
        {
            widget.openURL( storeUrl );
        }
	else
		{
		alert(num);
		alert(storeUrl);
		}
}
function openArtistUrl(num){
	var item , storeUrl;
	item = req.responseXML.getElementsByTagName("item")[num];
	storeUrl = item.getElementsByTagName("artistLink")[0] .firstChild.nodeValue;
	storeUrl = storeUrl.replace( "RD_PARM1=?http" , "RD_PARM1=http" );
 	if (window.widget)
        {
            widget.openURL( storeUrl );
        }
	else
		{
		alert(num);
		alert(storeUrl);
		}
}
function openHomePage(){
	if (window.widget){
		widget.openURL( 'http://deeptunes.info/widget/' );
	}
}
function enterbtn(obj){
	$(obj).style.background = "url(images/"+obj+"_on.png)"; 
}
function exitbtn(obj){
	$(obj).style.background = "url(images/"+obj+".png)"; 
}
var lineshow = true;
function enterJacket(event){
	if(lineshow){
		$("line1").style.opacity = 0.01;
		$("line2").style.opacity = 0.01;
		lineshow = false;
	}
}
function exitJacket(event){
	if(!lineshow){
		$("line1").style.opacity = 0.9;
		$("line2").style.opacity = 0.8;
		lineshow = true;
	}
}
function showBack()
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");
	
	document.getElementById("status").innerHTML = "";
	document.form.submit.disabled = false;
	
    if (window.widget)
        widget.prepareForTransition("ToBack");
		
    front.style.display="none";
    back.style.display="block";
	$("small").style.display = "none";
	
    if (window.widget)
        setTimeout ('widget.performTransition();', 0);  
}

function hideBack()
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");
	var newLimit = document.form.limit.value;
	limit = document.form.limit.value;
	var newCountry = document.form.country.value;
	store = document.form.country.value;
	if(window.widget)
	{
    	widget.setPreferenceForKey(newLimit,"limit");
    	widget.setPreferenceForKey(newCountry,"country");
	}
    if (window.widget)
        widget.prepareForTransition("ToFront");
		
    back.style.display="none";
    front.style.display="block";
	$("small").style.display = "block";
	loadRssDoc();
    if (window.widget)
        setTimeout ('widget.performTransition();', 0);
}

var flipShown = false;
var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null};
function mousemove (event)
{
    if (!flipShown)
    {
        if (animation.timer != null)
        {
            clearInterval (animation.timer);
            animation.timer  = null;
        }
		
        var starttime = (new Date).getTime() - 13;
		
        animation.duration = 500;
        animation.starttime = starttime;
        animation.firstElement = document.getElementById ('flip');
        animation.timer = setInterval ("animate();", 13);
        animation.from = animation.now;
        animation.to = 1.0;
        animate();
        flipShown = true;
    }
}
function mouseexit (event)
{
    if (flipShown)
    {
        if (animation.timer != null)
        {
            clearInterval (animation.timer);
            animation.timer  = null;
        }
		
        var starttime = (new Date).getTime() - 13;
		
        animation.duration = 500;
        animation.starttime = starttime;
        animation.firstElement = document.getElementById ('flip');
        animation.timer = setInterval ("animate();", 13);
        animation.from = animation.now;
        animation.to = 0.0;
        animate();
        flipShown = false;
    }
}
function animate()
{
    var T;
    var ease;
    var time = (new Date).getTime();
		
	
    T = limit_3(time-animation.starttime, 0, animation.duration);
	
    if (T >= animation.duration)
    {
        clearInterval (animation.timer);
        animation.timer = null;
        animation.now = animation.to;
    }
    else
    {
        ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
        animation.now = computeNextFloat (animation.from, animation.to, ease);
    }
	
    animation.firstElement.style.opacity = animation.now;
}
function limit_3 (a, b, c)
{
    return a < b ? b : (a > c ? c : a);
}
function computeNextFloat (from, to, ease)
{
    return from + (to - from) * ease;
}
function enterflip(event)
{
    document.getElementById('fliprollie').style.display = 'block';
}
function exitflip(event)
{
    document.getElementById('fliprollie').style.display = 'none';
}